﻿using HDF.PInvoke;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace HDFTestPlayground
{
    internal class PostedOnline
    {
        private static string _fileName = @"C:\test\TestHDF5.h5";

        private static void Main(string[] args)
        {
            float[] data = new float[10];
            for (int i = 0; i < data.Length; ++i)
            {
                data[i] = i;
            }

            var accessPropertyList = H5P.create(H5P.FILE_ACCESS);
            H5P.set_libver_bounds(accessPropertyList, H5F.libver_t.EARLIEST, H5F.libver_t.V18);
            long _fileID = H5F.create(_fileName, H5F.ACC_TRUNC, H5P.DEFAULT, accessPropertyList);
            ulong[] dims = { (ulong)data.Length };
            long dataSpaceID = H5S.create_simple(1, dims, null);
            long dataTypeID = H5T.IEEE_F32LE;
            long memoryTypeId = H5T.IEEE_F32LE;
            var plist = H5P.create(H5P.DATASET_CREATE);
            H5P.set_chunk(plist, 1, dims);
            H5P.set_deflate(plist, 6);
            H5P.set_fill_value(plist, H5T.IEEE_F32LE, IntPtr.Zero);
            var datasetID = H5D.create(_fileID, "test", dataTypeID, dataSpaceID, H5P.DEFAULT, plist, H5P.DEFAULT);
            GCHandle pinnedArrayHandle = GCHandle.Alloc(data, GCHandleType.Pinned);
            int answer = H5D.write(datasetID, memoryTypeId, H5S.ALL, H5S.ALL, H5P.DEFAULT, pinnedArrayHandle.AddrOfPinnedObject());

            H5D.close(datasetID);
            H5P.close(plist);
            H5F.close(_fileID);
            H5P.close(accessPropertyList);
        }

        private static void Online2Main(string[] args)
        {
            float[] data = new float[10];
            for (int i = 0; i < data.Length; ++i)
            {
                data[i] = i;
            }

            var accessPropertyList = H5P.create(H5P.FILE_ACCESS);
            H5P.set_libver_bounds(accessPropertyList, H5F.libver_t.EARLIEST, H5F.libver_t.LATEST);
            long _fileID = H5F.create(_fileName, H5F.ACC_TRUNC, H5P.DEFAULT, accessPropertyList);
            ulong[] dims = { (ulong)data.Length };
            long dataSpaceID = H5S.create_simple(1, dims, dims);
            long dataTypeID = H5T.IEEE_F32LE;
            long memoryTypeId = H5T.IEEE_F32LE;
            var plist = H5P.create(H5P.DATASET_CREATE);
            var datasetID = H5D.create(_fileID, "test", dataTypeID, dataSpaceID, H5P.DEFAULT, plist, H5P.DEFAULT);
            GCHandle pinnedArrayHandle = GCHandle.Alloc(data, GCHandleType.Pinned);
            int answer = H5D.write(datasetID, memoryTypeId, H5S.ALL, H5S.ALL, H5P.DEFAULT, pinnedArrayHandle.AddrOfPinnedObject());

            H5D.close(datasetID);
            H5P.close(plist);
            H5F.close(_fileID);
            H5P.close(accessPropertyList);
        }
    }
}